<template>
  <AppAbstractPage :breadcrumbs="$options.breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        Регистрация
      </h1>
    </div>

    <div
      slot="content"
      class="userRegister">
      <form
        class="userRegister-form"
        @submit.prevent="createUser();$ga('Shag2','Click47');$ym('modal_authorization_button_register');">
        <div class="userRegister-form-field">
          <AppCheckbox v-model="formRegister.isOrganization">
            <template #label>
              Я регистрируюсь как компания
            </template>
          </AppCheckbox>
        </div>

        <div class="userRegister-form-field">
          <AppInputComposite
            v-model="formRegister.username"
            type="text"
            name="username"
            :class="{ '-invalid': validation.hasError('formRegister.username') }">
            <template #label>Ваш E-mail</template>
          </AppInputComposite>
          <div
            v-if="validation.hasError('formRegister.username')"
            class="input-message-error _left">
            {{ validation.firstError('formRegister.username') }}
          </div>
        </div>

        <div class="userRegister-form-field">
          <AppInputComposite
            v-model="formRegister.password"
            type="password"
            name="password"
            :class="{ '-invalid': validation.hasError('formRegister.password') }">
            <template #label>Пароль</template>
          </AppInputComposite>
          <div
            v-if="validation.hasError('formRegister.password')"
            class="input-message-error _left">
            {{ validation.firstError('formRegister.password') }}
          </div>
        </div>

        <div class="userRegister-form-field">
          <AppCheckbox
            v-model="formRegister.isAgree"
            class="_label-small">
            <template #label>
              Принимаю
              <flink
                domain="main"
                href="/about-us/regulations"
                target="_blank"
                class="link">условия работы сайта</flink> и даю согласие на
              <flink
                domain="main"
                href="/about-us/agreement"
                target="_blank"
                class="link">обработку персональных данных</flink>.
            </template>
          </AppCheckbox>
        </div>

        <div
          v-if="error"
          class="userRegister-form-state">
          <div
            class="input-message-error"
            v-html="error"/>
        </div>

        <div class="userRegister-form-options">
          <AppButton
            type="submit"
            :disabled="isSubmitRegisterDisabled || !isPassedFormRegister">
            <span
              slot="button-item"
              class="button-item">
              Зарегистрироваться
            </span>
          </AppButton>
        </div>

      </form>
    </div>
  </AppAbstractPage>
</template>

<script>
import { get } from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import { LOGIN } from '~/assets/js/store/user/action-types';

import SimpleVueValidation from 'simple-vue-validator';
import Validator from '~/assets/js/validator';

import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/users/register';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';

import RequestState from '~/assets/js/enums/request-state';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
    minLength: 'Слишком короткий пароль.',
  },
});

const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'PageRegister',
  components: {
    AppAbstractPage,
    AppButton,
    AppCheckbox,
    AppInputComposite,
  },
  mixins: [SeoMixin, SeoPageMixin],
  middleware: ({ store, redirect }) => !store.state.user.auth || redirect('/'),
  data() {
    return {
      formRegister: {
        username: '',
        password: '',
        isOrganization: false,
        isAgree: false,
      },
      error: '',
    };
  },
  computed: {
    isSubmitRegisterDisabled() {
      return !this.formRegister.isAgree
              || !Validator.notBlank(this.formRegister.username)
              || !Validator.notBlank(this.formRegister.password);
    },
    isPassedFormRegister() {
      return this.validation.isPassed('formRegister.username') && this.validation.isPassed('formRegister.password');
    },
  },
  validators: {
    'formRegister.username'(value) {
      return SimpleVueValidator.value(value).required().email();
    },
    'formRegister.password'(value) {
      return SimpleVueValidator.value(value).required().minLength(6);
    },
    'formRegister.isAgree'(value) {
      return this.validation.isTouched('formRegister.isAgree') && SimpleVueValidator.value(value).match(true);
    },
  },
  created() {
    this.$options.breadcrumbs = [
      {
        url: '',
        name: 'Регистрация',
      },
    ];
  },
  methods: {
    ...STORE_USER.mapActions({
      login: LOGIN,
    }),
    async requestCreateUser() {
      this.error = '';

      try {
        const response = await this.$axios.$post('/_main/user/create', {
          username: this.formRegister.username,
          password: this.formRegister.password,
          isOrganization: this.formRegister.isOrganization,
        });

        return response && response.type === RequestState.SUCCESS;
      } catch (e) {
        const { data } = e.response;

        if (data.message) {
          this.error = get(e, 'response.data.error.errorCode', null) === 401
            ? data.message
            : 'Произошла ошибка, пожалуйста, попробуйте повторить запрос позднее';
        }

        console.error(e);
      }

      return false;
    },
    async requestLoginUser() {
      this.error = '';

      try {
        await this.login({
          username: this.formRegister.username,
          password: this.formRegister.password,
        });
        return true;
      } catch (e) {
        const { data } = e.response;

        if (data.message) {
          this.error = get(e, 'response.data.error.errorCode', null) === 401
            ? data.message
            : 'Произошла ошибка, пожалуйста, попробуйте повторить запрос позднее';
        }

        console.error(e);
      }

      return false;
    },
    async createUser() {
      const isValid = await this.$validate();

      if (isValid) {
        const isUserCreate = await this.requestCreateUser();

        if (isUserCreate) {
          // TODO: Как только будет готов новый фронт, window.location.href заменим
          // на this.$router.push()

          const dataLogin = await this.requestLoginUser();

          if (dataLogin) {
            // TODO: Как только будет готов новый фронт, window.location.href заменим
            // на this.$router.push()
            window.location.href = '/cabinet/wrench/profile';
          }
        }
      }
    },
  },
};

</script>

<style lang="postcss">

  .userRegister {

    & .userRegister-form {
      max-width: 400px;

      & .userRegister-form-state {
        margin-bottom: 1rem;

        & > .input-message-error {
          display: block;
          padding-top: 0;
        }
      }
    }

    & .userRegister-form-field {
      padding-bottom: 1rem;
    }

  @media only screen and (min-width: 980px ) and (max-width: 1365px) {
      & .userRegister-form-options {
          padding-bottom: 2rem;
      }
  }

    @media only screen and ( max-width: 980px ) {
      padding: 0 1.25rem 1.25rem 1.25rem;
    }
  }

</style>
